<?php
/*	
	Moderate Plugin
	For Spam Karma 2
	Version 0.75 beta
	Copyright 2005 Peter Westwood  

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

class sk2_pjw_moderate extends sk2_plugin
{
	var $name = "Moderate";
	var $plugin_version = 0.75;
	var $release_string =" beta";
	var $show_version = true;
	var $author = "Peter Westwood";
	var $author_email = "peter.westwood@ftwr.co.uk";
	var $plugin_help_url = "http://blog.ftwr.co.uk/wordpress/sk2-moderate-plugin/";
	var $description = "Forces comment moderation based on settings in WordPress admin panel. Enforces the following settings:<ul><li>An administrator must approve the comment (regardless of any matches below)</li><li>Comment author must have a previously approved comment</li></ul>";
	var $filter = true;
	var $weight_levels = array("0" => "Disabled",  "1.0" => "Enabled");
	var $skip_under = 0; // No point running if already in moderation
	var $skip_above = 1000; // Make it high just in case

	function filter_this(&$cmt_object)
	{
			// WordPress setting "An administrator must approve the comment (regardless of any matches below)"
			if( 1 == get_settings( "comment_moderation" ))
			{
				if ($cmt_object->karma > 0.0)
					$this->hit_karma($cmt_object, ($cmt_object->karma + 1.0),
									 'Spank into moderation - All comments must be moderated.');
			}

			// WordPress setting "Comment author must have a previously approved comment"
			// This is kind of enforce by SpamKarma2 already - it gives positive karma to previous commenters.
			if( 1 == get_settings("comment_whitelist"))
			{
				global $wpdb;
				//Check here borrowed from WordPress core code.
				$ok_to_comment = $wpdb->get_var("SELECT comment_approved FROM $wpdb->comments WHERE comment_author = '"
												.$cmt_object->author."' AND comment_author_email = '"
												.$cmt_object->author_email."' and comment_approved = '1' LIMIT 1");
	            if ( 0 == $ok_to_comment )
					$this->hit_karma($cmt_object, ($cmt_object->karma + 1.0),
									 'Spank into moderation - Author has no previously approved comments.');
			}
	}
}

/* Move the register to end so that the class is declared first - some versions of PHP require this.*/
$this->register_plugin("sk2_pjw_moderate",25); //Run Last after everything else
?>
